//
// freq.c - creates frequency tables
//

#include "stdio.h"
#include "math.h"

#define TUNING 440.0

double getfrequency(int note, int octave) {
	return TUNING * pow(2., (note-9) / 12. + octave);
}

int main(int argc, char* argv[]) 
{
	int note, octave;
	double frequency;
	unsigned int period;

	for(octave=-4;octave<5;octave++) {
		printf("; Octave %i:\n", octave);
		for(note=0;note<12;note++) {
			frequency = getfrequency(note,octave);
			/* From the NC100 I/O specification file:
			The frequency generated is determined as:
		
	        Frequency = 1,000,000d
	   	                ----------
	 	                data * 2 * 1.6276*/
			period = (int)(1000000. / (frequency * 3.2552));
			printf("db &%02X,&%02X ; f=%fHz\n", (period % 256), (period / 256), frequency ); // output in little-endian
		}
	}
	printf("\n");
}
